#!/usr/bin/perl
# Generated automatically from add_filter.pl.in by configure.

use lib '/usr/share/news-peruser';
use Peruser;

# This script allows the user to create an entry in ~/.peruser4-filters,
# consisting of a regular expression filter and an associated folder name.

$cancelled = '(cancelled)';

$query = "'Enter the name of an existing folder you\\n" .
          "would like to associate with a regular expression filter:'";
$folder = `npgettext $query`;

exit( 0 ) if ( $folder eq $cancelled );

$filter = `npgettext 'Enter the regular expression to use as the filter:'`;

exit( 0 ) if ( $filter eq $cancelled );

unless( safe_open( \*FOLDERS, "$home/.peruser4-folders" ))
{
   feedback( "Create $folder first.\n" );
   exit( 0 );
}

$found = 0;

while( <FOLDERS> )
{
   chop;

   if ( $_ eq $folder )
   {
      $found = 1;
      last;
   }
}

safe_close( \*FOLDERS );

if ( not $found )
{
   feedback( "Create $folder first.\n" );
   exit( 0 );
}

exit( 1 ) unless( safe_open( \*FILTERS, "+>>$home/.peruser4-filters" ));

unless( seek FILTERS, 0, SEEK_SET )
{
   feedback( "Cannot seek to start of $spooldir/.peruser4-filters: $!\n" );
   exit( 1 );
}

while( <FILTERS> )
{
   chop;

   s/\\:/&/g;

   @list = split /:/;

   if ( $list[ 0 ] eq $filter )
   {
      feedback( "filter $filter is already associated with $list[ 1 ]\n" );
      safe_close( \*FILTERS );
      exit( 1 );
   }
}

unless( seek FILTERS, 0, SEEK_END )
{
   feedback( "Cannot seek to end of $spooldir/.peruser4-filters: $!\n" );
   exit( 1 );
}

$filter =~ s/:/\\:/g;
$folder =~ s/:/\\:/g;

print FILTERS "$filter:$folder\n";
safe_close( \*FILTERS );
