#!/usr/bin/perl
# Generated automatically from rm_dups.pl.in by configure.

use lib '/usr/share/news-peruser';
use Peruser;

# Removes duplicate articles from spool files.

sub by_position
{
   return $a->[ 3 ] <=> $b->[ 3 ];
}

sub advance
{
   my $copy = shift;
   my $line;

   if ( $copy == 0 || $copy == 1 )
   {
      do
      {
         $line = <SPOOL>;
         if ( $copy == 1 )
         {
            print TEMP $line;
         }
      }
      while( $line ne ".\r\n" );
   }
   elsif( $copy == 2 || $copy == 3 )
   {
      $line = <READ>;
      if( $copy == 3 )
      {
         print TEMP_READ $line;
      }
   }
}

sub fix_files
{
   while( not eof SPOOL )
   {
      advance( 1 );
      advance( 3 );
   }

   safe_close( \*SPOOL );
   safe_close( \*TEMP );
   rename "$spool:tmp", "$spool";

   safe_close( \*READ );
   safe_close( \*TEMP_READ );
   rename "$spool:read:tmp", "$spool:read";
}

@servers = get_servers();
exit( 0 ) if ( $#servers < 0 );

foreach $server ( @servers )
{
   next if ( $server eq 'Folders' );
   @groups = get_groups( $server );
   next if ( $#groups < 0 );

   foreach $group ( @groups )
   {
      $count = 0;
      next unless( safe_open( \*SPOOL, "$spooldir/$server-$group" ));

      while( <SPOOL> )
      {
         if ( $_ eq "\r\n" )
         {
            advance( 0 );
            ++$count;
         }

         if ( $_ eq ".\r\n" )
         {
            ++$count;
            next;
         }

         if ( /Message-ID: +<([^>]+)>/i )
         {
            push @list, [ $1, $server, $group, $count, 0 ];
            advance( 0 );
            ++$count;
         }
      }

      safe_close( \*SPOOL );
   }
}

if ( $#list < 0 )
{
   feedback( "No articles in database." );
   exit 0;
}

for( $item = shift @list; defined $item; $item = shift @list )
{
   foreach $other ( @list )
   {
      if ( $item->[ 0 ] eq $other->[ 0 ] )
      {
         push @dups, $other;
      }
   }
}

if( $#dups < 0 )
{
   feedback( "No duplicate messages found." );
   exit 0;
}

@list = ();

foreach $server ( @servers )
{
   next if ( $server eq 'Folders' );
   @groups = get_groups( $server );
   next if( $#groups < 0 );

   foreach $group ( @groups )
   {
      @temp = ();

      foreach $item ( @dups )
      {
         if ( $item->[ 1 ] eq $server && $item->[ 2 ] eq $group )
         {
            next if ( $item->[ 4 ] == 1 );
            push @temp, $item;
            $item->[ 4 ] = 1;
         }
      }

      next if ( $#temp < 0 );

      @temp = sort by_position @temp;
      push @list, ( @temp );
   }
}

@temp = ();
@dups = ();
$quantity = 0;

$server = $group = undef;

foreach $item ( @list )
{
   if( $item->[ 1 ] ne $server || $item->[ 2 ] ne $group )
   {
      if( defined $server )
      {
         fix_files();
         push @dups, [ $server, $group, $quantity ];
         $total += $quantity;
      }

      $server = $item->[ 1 ];
      $group = $item->[ 2 ];
      $spool = "$spooldir/$server-$group";

      $count = 0;
      $quantity = 0;

      die unless( safe_open( \*SPOOL, "$spool" ));
      die unless( safe_open( \*TEMP, ">$spool:tmp" ));
      die unless( safe_open( \*READ, "$spool:read" ));
      die unless( safe_open( \*TEMP_READ, ">$spool:read:tmp" ));
   }

   ++$quantity;
   $position = $item->[ 3 ] - $count;
   die if ( $position < 0 );

   while( $position-- )
   {
      advance( 1 );
      advance( 3 );
      ++$count;
   }

   advance( 0 );
   advance( 2 );
   ++$dups;
   ++$count;
}

fix_files();
push @dups, [ $server, $group, $quantity ];
$total += $quantity;

$reply = "$total duplicate articles removed from database:\n\n";

foreach $item ( @dups )
{
   $reply .= "$item->[ 0 ]: $item->[ 1 ]: $item->[ 2 ]\n";
}

feedback( $reply );
0;
